"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = require("@pnpm/logger");
const list_1 = require("../list");
exports.default = (pkgs, args, cmd, opts) => __awaiter(this, void 0, void 0, function* () {
    const outputs = [];
    for (const pkg of pkgs) {
        try {
            const output = yield list_1.render(args, Object.assign({}, opts, { prefix: pkg.path, alwaysPrintRootPackage: opts.depth === -1 }), cmd);
            if (!output)
                continue;
            outputs.push(output);
        }
        catch (err) {
            logger_1.default.info(err);
            err['prefix'] = pkg.path; // tslint:disable-line:no-string-literal
            throw err;
        }
    }
    if (outputs.length === 0)
        return;
    const joiner = opts.depth && opts.depth > -1 ? '\n\n' : '\n';
    const allOutput = outputs.join(joiner);
    console.log(allOutput);
});
//# sourceMappingURL=list.js.map