"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const dint = require("dint");
const loadJsonFile = require("load-json-file");
const path = require("path");
function untouched(pkgDir) {
    return __awaiter(this, void 0, void 0, function* () {
        let dirIntegrity = null;
        try {
            dirIntegrity = yield loadJsonFile(path.join(path.dirname(pkgDir), 'integrity.json'));
        }
        catch (err) {
            if (err.code !== 'ENOENT')
                throw err;
            return false; // for backward compatibility
        }
        return dint.check(pkgDir, dirIntegrity)
            .then((ok) => ok && dirIntegrity);
    });
}
exports.default = untouched;
//# sourceMappingURL=index.js.map