"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const load_json_file_1 = require("load-json-file");
const path = require("path");
const write_json_file_1 = require("write-json-file");
const STORE_JSON = 'store.json';
function read(storePath) {
    return __awaiter(this, void 0, void 0, function* () {
        const storeJsonPath = path.join(storePath, STORE_JSON);
        try {
            return yield load_json_file_1.default(storeJsonPath);
        }
        catch (err) {
            if (err.code !== 'ENOENT') {
                throw err;
            }
            return null;
        }
    });
}
exports.read = read;
function save(storePath, store) {
    const storeJsonPath = path.join(storePath, STORE_JSON);
    return write_json_file_1.default(storeJsonPath, store);
}
exports.save = save;
function saveSync(storePath, store) {
    const storeJsonPath = path.join(storePath, STORE_JSON);
    return write_json_file_1.sync(storeJsonPath, store);
}
exports.saveSync = saveSync;
//# sourceMappingURL=storeIndex.js.map