"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const PnpmError_1 = require("./PnpmError");
class BadTarballError extends PnpmError_1.default {
    constructor(opts) {
        const message = `Actual size (${opts.receivedSize}) of tarball (${opts.tarballUrl}) did not match the one specified in \'Content-Length\' header (${opts.expectedSize})`;
        super('BAD_TARBALL_SIZE', message);
        this.expectedSize = opts.expectedSize;
        this.receivedSize = opts.receivedSize;
    }
}
exports.default = BadTarballError;
//# sourceMappingURL=BadTarballError.js.map