"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const read_package_json_1 = require("@pnpm/read-package-json");
const path = require("path");
function safeReadPkg(pkgPath) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            return yield read_package_json_1.default(pkgPath);
        }
        catch (err) {
            if (err.code !== 'ENOENT')
                throw err;
            return null;
        }
    });
}
exports.default = safeReadPkg;
function fromDir(pkgPath) {
    return safeReadPkg(path.join(pkgPath, 'package.json'));
}
exports.fromDir = fromDir;
//# sourceMappingURL=safeReadPkg.js.map